* Citation:
*    Subal Kumbhakar and Hung-Jen Wang, "Estimation of Growth Convergence Using a Stochastic
*    Production Frontier Approach," Economics Letters, 2005, 88(3), pp.300-305.


set trace off
clear
set more off

capture log close
log using _log8c.txt, text replace



use data1


quie gen double year = yr

replace l = l*h


foreach X in y k l h {
 quie gen double ln`X' = ln(`X')
}

quie gen double lnk2 = lnk*lnk
quie gen double lnl2 = lnl*lnl
quie gen double lnkl = lnk*lnl

quie tab code, gen(cdum)
drop cdum1


sort code year
quie by code: gen double tem1 = lnk - lnl if _n == 1 /* beginning period of ln(k/l) */
quie by code: egen double iniStat = mean(tem1)


quie gen year2 = year-1


global xvar0cd lnk lnl yr
global xvar0 lnk lnl lnk2 lnl2 lnkl yr


quie reg lny $xvar0cd
mat b0 = e(b)

quie gen byte gamma_const = 1



 ***** time-decay model, used in our EL paper; Cobb-Douglas ********

sfpan  lny, dist(t) mu(iniStat) prod frontier($xvar0cd)  usigmas vsigmas gamma(year2, nocons) i(code)
ml init b0 0 0 -0.012 -0.9 0, copy
sf_srch, frontier($xvar0cd) usigmas() vsigmas() n(1) gamma(year2) mu(iniStat)
ml max, difficult gradient nrtol(0.001) gtol(0.001)

sf_predict, bc(bc_cd3) jlms(jlms_cd3) nomarginal /* note, both BC and JLMS scores are calculated */
